(*  Title:      src/Tools/isac/BridgeJEdit/Calculation.thy
    Author:     Walther Neuper, JKU Linz

Outer syntax for Isabelle/Isac's Calculation interactive via Isabelle/PIDE.
Second trial following Makarius' definition of "problem" already existing in this repository.
*)

theory Calculation
  imports E_Collect "$ISABELLE_ISAC/Knowledge/Build_Thydata"
  keywords "Example" :: thy_decl
    and "Specification" "Model" "References" "Solution" 
begin

ML_file "user-model.sml"
ML_file "template.sml"
ML_file "preliminary.sml"
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>Outer syntax command \<^theory_text>\<open>Example\<close>\<close>

text \<open>
  Stepwise development starts at changeset
  \<^url>\<open>https://hg.risc.uni-linz.ac.at/wneuper/isa/rev/9d98791b4080\<close>
  and can be inspected following the subsequent changesets..
\<close>

subsection \<open>store for the state of a calculation\<close>
ML \<open>
(**)
structure Data = Theory_Data
(
  type T = CTbasic_POS.ctree option;
  val empty = NONE;
  fun merge _ = NONE;
);

val set_data = Data.put o SOME;
fun the_data thy = 
  case Data.get thy of NONE => CTbasic_POS.EmptyPtree
  | SOME ctree => ctree;
\<close> ML \<open>
\<close>

subsection \<open>Outer_Syntax.command\<close>
ML \<open>
val _ =
  Outer_Syntax.command \<^command_keyword>\<open>Example\<close>
    "prepare ISAC problem type and register it to Knowledge Store"
    (Parse.name -- Parse.!!! ( \<^keyword>\<open>Specification\<close> -- \<^keyword>\<open>:\<close> --
         \<^keyword>\<open>Model\<close> -- \<^keyword>\<open>:\<close>  |-- Problem.parse_pos_model_input --
           (\<^keyword>\<open>References\<close> -- \<^keyword>\<open>:\<close> |-- Parse.!!! References.parse_input_pos
             (** )-- ( \<^keyword>\<open>Solution\<close> -- keyword>\<open>:\<close>)( ** )WHAT IS WRONG HEREWITH?( **)) ) >>
      (fn (example_id, (model_input,
          ((thy_id, thy_id_pos), ((probl_id, probl_id_pos), (meth_id, meth_id_pos)) ) )) =>
        Toplevel.theory (fn thy =>
          let
            val state =
              case the_data thy of
                  CTbasic_POS.EmptyPtree => Preliminary.init_ctree thy example_id
                | state =>
                  let
                    val {origin = (o_model, o_ref, _), spec = spec_ref, probl, meth, ctxt, ...} =
                      CTbasic_POS.get_obj I state [(*Pos will become variable*)] |> CTbasic_POS.rep_specify_data
                    val thy_id' = References.for_parse thy_id (#1 spec_ref) (#1 o_ref)
                    val (model, where_) = Model_Pattern.parse_pos_empty ctxt model_input (*+check syntax*)
(** )
                    val _ = re_eval References.empty References.empty
( **)
                  in
                    Preliminary.update_state thy
                      (example_id, (model_input, (thy_id, probl_id, meth_id))) (the_data thy)
                  end
          in set_data state thy end)));
\<close> ML \<open>
(*/-------------------------------------------------------------------------------------------\*)
Parse.name -- Parse.!!! ( \<^keyword>\<open>Specification\<close> -- \<^keyword>\<open>:\<close> --
         \<^keyword>\<open>Model\<close> -- \<^keyword>\<open>:\<close>  |-- Problem.parse_pos_model_input --
                  (\<^keyword>\<open>References\<close> -- \<^keyword>\<open>:\<close> |-- Parse.!!! References.parse_input_pos))
(*\-------------------------------------------------------------------------------------------/*)
(*/-------------------------------------------------------------------------------------------\*)
: Token.T list ->
    (string *                              (Model_Pattern.model_input_pos *
      ((string * Position.T) * ((string * Position.T) * (string * Position.T))))) * Token.T list;
(* ---------- the type above is the type of the argument of \<open>(fn (example_id, ...\<close> ------------*)
(*\-------------------------------------------------------------------------------------------/*)

(*/---------------------------------------- mimic input from PIDE ----------------------------\*)
val example_id = "Diff_App-No.123a"
val model_input = [("#Given", [("Constants [r = 7]", Position.none)])]
val (thy_id, probl_id, meth_id) =
  ("Diff_App", "univariate_calculus/Optimisation", "Optimisation/by_univariate_calculus");
(* ---------- ^^^ values for arguments of the fn below in order to determine signature -------*)
      (fn thy =>
          let
            val store = CTbasic_POS.EmptyPtree;
          in set_data store thy end)
: theory -> theory
(*\---------------------------------------- mimic input from PIDE ----------------------------/*)
\<close> ML \<open>
\<close>

end
