(* Title:  "BridgeJEdit/template.sml"
   Author: Walther Neuper
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- build Template.show ---------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

open Template;
"----------- build Template.show ---------------------------------------------------------------";
"----------- build Template.show ---------------------------------------------------------------";
"----------- build Template.show ---------------------------------------------------------------";
(*/---------------------------------------- mimic input from PIDE -----------------------------\*)

(* Test_Example "Diff_App-No.123a" (*complete Model, empty References*) *)
val in_refs as (thy_id, probl_id, meth_id) = ("__", "__/__", "__/__")
val thy = @{theory}
val model_input = (*type Position.T is hidden, thus redefinition*)
 [("#Given", [("Constants [r = 7]", Position.none)]),
  ("#Where", [("0 < r", Position.none)]),
  ("#Find",
   [("Maximum A", Position.none), ("AdditionalValues [u, v]", Position.none)]),
  ("#Relate",
   [("Extremum (A = 2 * u * v - u \<up> 2)", Position.none),
    ("SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]", Position.none)])]
: (Model_Pattern.m_field * (string * Position.T) list) list
val example_id = "Diff_App-No.123a";
(*----------------------------------------- init state -----------------------------------------*)
set_data CTbasic_POS.EmptyPtree @{theory Calculation};
(*\---------------------------------------- mimic input from PIDE -----------------------------/*)

val CTbasic_POS.EmptyPtree =
              (*case*) the_data @{theory Calculation} (*of*);

(* Calculation.thy..*)
"~~~~~ fun init_ctree , args:"; val (thy, example_id) = (thy, example_id);
      val user_ctxt = Proof_Context.init_global thy
      val example_id' = References_Def.explode_id example_id
      val (_, (formalise as (model, refs as (thy_id, probl_id, meth_id)))) =
        Store.get (Know_Store.get_expls @{theory}) example_id' example_id' 
      val calc_thy = ThyC.get_theory user_ctxt thy_id
      val {model = model_patt, ...} = Problem.from_store user_ctxt probl_id
      val (o_model, ctxt) = O_Model.init calc_thy model model_patt
;
(*+*)o_model: O_Model.T; (* |> O_Model.to_string @{context}*)
(*+*)val "Diff_App" = ctxt |> Proof_Context.theory_of |> ThyC.id_of
(*+*)val ("Diff_App", ["univariate_calculus", "Optimisation"], ["Optimisation", "by_univariate_calculus"]) =
(*+*)  refs

      val empty_i_model = I_Model.init_POS user_ctxt o_model model_patt;

(*+*)if I_Model.to_string_POS @{context} empty_i_model = "[\n" ^
(*+*)  "(1, [1, 2, 3], false ,#Given, (Inc_POS Constants [] [__=__, __=__], Position.T)), \n" ^
(*+*)  "(2, [1, 2, 3], false ,#Find, (Inc_POS Maximum __, Position.T)), \n" ^
(*+*)  "(3, [1, 2, 3], false ,#Find, (Inc_POS AdditionalValues [] [__, __], Position.T)), \n" ^
(*+*)  "(4, [1, 2, 3], false ,#Relate, (Inc_POS Extremum (__=__), Position.T)), \n" ^
(*+*)  "(5, [1, 2], false ,#Relate, (Inc_POS SideConditions [] [__=__, __=__], Position.T))]"
(*+*)then () else error "final test of build I_Model.init_POS FAILED";

      val {where_rls, where_, ...} = MethodC.from_store ctxt meth_id;
      val (_, preconds) = Pre_Conds.check ctxt where_rls where_ (model_patt, empty_i_model);

           show ctxt preconds empty_i_model in_refs;
"~~~~~ fun show , args:"; val (ctxt, preconds, i_model, in_refs) =
   (ctxt, preconds, empty_i_model, in_refs);
(*+*)val "[\n(1, [1, 2, 3], false ,#Given, (Inc_POS Constants [] [__=__, __=__], Position.T)), \n(2, [1, 2, 3], false ,#Find, (Inc_POS Maximum __, Position.T)), \n(3, [1, 2, 3], false ,#Find, (Inc_POS AdditionalValues [] [__, __], Position.T)), \n(4, [1, 2, 3], false ,#Relate, (Inc_POS Extremum (__=__), Position.T)), \n(5, [1, 2], false ,#Relate, (Inc_POS SideConditions [] [__=__, __=__], Position.T))]"
 = i_model |> I_Model.to_string_POS @{context}
  (*let*)
    val model_out =
           model_to_out ctxt preconds i_model;
"~~~~~ fun model_to_out , args:"; val (ctxt, where_, model) = (ctxt, preconds, i_model);

    val given =
           items_to_out ctxt "#Given" model;
"~~~~~ fun items_to_out , args:"; val (ctxt, m_field, items) = (ctxt, "#Given", model);

val return_ = (m_field, filter (fn (_, _, _, f, _) => f = m_field) items |>
      map (item_to_out ctxt));
"~~~~~ fun item_to_out , args:"; val (ctxt, (_, _, _, _, (I_Model.Inc_POS ((dsc, [])), _))) =
  (ctxt, nth 1 items);
val return_ = (UnparseC.term ctxt dsc ^ " " ^ Model_Pattern.empty_for dsc, Incomplete)

(*+*)val ("Constants [__=__, __=__]", Incomplete) = return_
(*|------------------- contine show ----------------------------------------------------------*)
    val fake_string = model_to_string model_out ^ refs_to_string in_refs
    val _ = writeln fake_string
;
if fake_string =
  "  Specification:\n" ^
  "    Model:\n" ^
  "      #Given: \"Constants [__=__, __=__]\" (Incomplete)\n" ^
  "      #Where: \n" ^
  "      #Find: \"Maximum __\" (Incomplete)\n" ^
  "        \"AdditionalValues [__, __]\" (Incomplete)\n" ^
  "      #Relate: \"Extremum (__=__)\" (Incomplete)\n" ^
  "        \"SideConditions [__=__, __=__]\" (Incomplete)\n" ^
  "    References:\n      Theory_Ref: \"__\"\n" ^
  "      Problem_Ref: \"__/__\"\n" ^
  "      Method_Ref: \"__/__\"\n" ^
  "  Solution:"
then () else error "final test of build Template.show CHANGED"
